#include <stdio.h>
#include <stdlib.h>
#include "header.h"
#include <mkl.h> //ヘッダのインクルードが必要

//mklのsolverをblack-box的に使用している
//solutionという配列を渡し、そこに答えがはいる
//係数行列LEFTと右辺ベクトルRHSを渡す
//ただし、use_lapackを行うと、RHSの値が書き換わるので、書き換えたくない場合、
//実装を変更すること

void use_lapack(double *solution,int tDOF, double **LEFT, double *RHS){
  int c,d;
  int N=tDOF;
  int NRHS=1;
  int LDA=N;
  int LDB=N;
  /* Locals */
  MKL_INT n = N, nrhs = NRHS, lda = LDA, ldb = LDB, info;
  /* Local arrays */
  MKL_INT ipiv[N];
  double *a;
  a = (double*)malloc(sizeof(double)*LDA*N);  
  for(c=0;c<tDOF;c++){
    for(d=0;d<tDOF;d++){
      a[d*tDOF+c]=LEFT[c][d];
    }
  }
  /* Solve the equations A*X = B */
  dgesv( &n, &nrhs, a, &lda, ipiv, RHS, &ldb, &info );
  /* Check for the exact singularity */
  if( info > 0 ) {
    printf( "The diagonal element of the triangular factor of A,\n" );
    printf( "U(%i,%i) is zero, so that A is singular;\n", info, info );
    printf( "the solution could not be computed.\n" );
    exit( 1 );
  }
  for(c=0;c<tDOF;c++){
    solution[c]=RHS[c];
  }
  free(a);
}
